#include <avr/io.h>
#include <util/delay.h>
#include "rf12.cpp"
#define UBRR_VAL 12
#include "uart.cpp"
uint8_t uart_buf;
unsigned char buffer[32];
unsigned char rf_buffer[32];
uint8_t buf_count=0, rfm_buf;
void long_delay(uint16_t ms)
{
	for(;ms>0;ms--)_delay_ms(1);            
}
int main(void)
{
	DDRD = 0b01111100;
	PORTD = (1<<PD6);						//Selbsthaltung
	DDRB = 0b00;
	PORTB = 0xff;
	uart_init();
	long_delay(50);
	RFM12B_init_hard();
	RFM12B_init_soft();
	long_delay(800);
	if(UDR != 156)
	{
		PORTD &= ~(1<<PD6);
		while(1)asm volatile("NOP");
	}
	uart_putc(16);					
	RFM12B_init_hard();
	RFM12B_init_soft();
	UCSRB |= (1<<TXEN);	
	uint8_t i;
	TCCR1B |= (1<<CS12) | (1<<CS10);
	while(1)
	{
		if(UCSRA & (1<<RXC))
		{
			uart_buf = uart_getc();
			if(uart_buf==12)
			{
				for(i=1;i<31;i++)
				{
					buffer[i]=uart_getc();
					if(buffer[i]==157)
					{
						PORTD &= ~(1<<PD6);
						while(1)asm volatile("NOP");
					}
				}
				buffer[0]=12;
				buffer[31]='\0';
				RFM12B_transmit(buffer, 32);
			}
			else if(uart_buf==157)
			{
				PORTD &= ~(1<<PD6);
				while(1)asm volatile("NOP");
			}			
		}
		if(bit_is_set(PIND, PD0))
		{
			TCNT1 = 0;
		}
		if(TCNT1>200)
		{
			PORTD &= ~(1<<PD6);
			while(1)asm volatile("NOP");
		}					
		if(RFM12B_FFIT())
		{
			rfm_buf = RFM12B_spi(0xB000) & 0x00FF;
			if(rfm_buf==12)
			{
				buf_count=1;
				rf_buffer[0]=12;
			}
			else
			{
				if(rfm_buf==0)rfm_buf=255;
				rf_buffer[buf_count]=rfm_buf;
				buf_count++;
			}
			if(buf_count==31)
			{
				buf_count=1;
				uart_putc(12);
				for(i=1;i<31;i++)
				{
					uart_putc(rf_buffer[i]);
					uart_getc();
				}
			}
		}
	}
}
